"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const Builder_1 = require("./Builder");
__export(require("./Raw"));
__export(require("./Type"));
var Type_1 = require("./Type");
exports.type = Type_1.Type;
__export(require("./ColumnDefinition"));
__export(require("./BaseStatement"));
__export(require("./SelectStatement"));
__export(require("./UpdateStatement"));
__export(require("./InsertStatement"));
__export(require("./DeleteStatement"));
__export(require("./CreateKeyspaceStatement"));
__export(require("./CreateColumnFamilyStatement"));
__export(require("./CreateColumnFamilyIndexStatement"));
__export(require("./CreateMaterializedViewStatement"));
__export(require("./CreateTypeStatement"));
__export(require("./Builder"));
const builder = new Builder_1.Builder();
let { token, ttl, now, timestamp, delete: deleteRow, select, update, insert, createKeyspace, createColumnFamily, createMaterializedView, createIndex, } = builder;
exports.token = token;
exports.ttl = ttl;
exports.now = now;
exports.timestamp = timestamp;
exports.deleteRow = deleteRow;
exports.select = select;
exports.update = update;
exports.insert = insert;
exports.createKeyspace = createKeyspace;
exports.createColumnFamily = createColumnFamily;
exports.createMaterializedView = createMaterializedView;
exports.createIndex = createIndex;
exports.token = token = token.bind(builder);
exports.ttl = ttl = ttl.bind(builder);
exports.now = now = now.bind(builder);
exports.timestamp = timestamp = timestamp.bind(builder);
exports.deleteRow = deleteRow = deleteRow.bind(builder);
exports.select = select = select.bind(builder);
exports.update = update = update.bind(builder);
exports.insert = insert = insert.bind(builder);
exports.createKeyspace = createKeyspace = createKeyspace.bind(builder);
exports.createColumnFamily = createColumnFamily = createColumnFamily.bind(builder);
exports.createMaterializedView = createMaterializedView = createMaterializedView.bind(builder);
exports.createIndex = createIndex = createIndex.bind(builder);
//# sourceMappingURL=index.js.map