import { BaseStatement } from './BaseStatement';
import { Raw } from './Raw';
import { StringKey, TransformPossibleColumnDefinition } from './ColumnDefinition';
export declare type WhereEntry<S extends TransformPossibleColumnDefinition, K extends StringKey<S>> = ([K, '>' | '<' | '=' | 'CONTAINS', S[K]]) | ([K, 'IS NOT NULL']) | ([K, 'IN', (Raw | any)[]]) | ([[K], '>' | '<' | '=', [S[K]][]]);
export declare type WhereEntryMulti2<S extends TransformPossibleColumnDefinition, K1 extends StringKey<S>, K2 extends StringKey<S>> = ([[K1, K2], '>' | '<' | '=', [S[K1], S[K2]][]]);
export declare type WhereEntryMulti3<S extends TransformPossibleColumnDefinition, K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>> = ([[K1, K2, K3], '>' | '<' | '=', [S[K1], S[K2], S[K3]][]]);
export declare type WhereEntryMulti4<S extends TransformPossibleColumnDefinition, K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>> = ([[K1, K2, K3, K4], '>' | '<' | '=', [S[K1], S[K2], S[K3], S[K4]][]]);
export declare type WhereEntryMulti5<S extends TransformPossibleColumnDefinition, K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>> = ([[K1, K2, K3, K4, K5], '>' | '<' | '=', [S[K1], S[K2], S[K3], S[K4], S[K5]][]]);
export declare class WhereStatement<S extends TransformPossibleColumnDefinition = TransformPossibleColumnDefinition, P extends {
    [name: string]: any;
} = {}> extends BaseStatement<P> {
    protected whereClauseDefs: Raw[];
    where(selection: Raw): this;
    where<K extends StringKey<S>>(keys: [K], comparator: 'IN', valueList: [S[K]][]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], comparator: 'IN', valueList: [S[K1], S[K2]][]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], comparator: 'IN', valueList: [S[K1], S[K2], S[K3]][]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], comparator: 'IN', valueList: [S[K1], S[K2], S[K3], S[K4]][]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], comparator: 'IN', valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]][]): this;
    where<K extends StringKey<S>>(keys: [K], comparator: '>' | '<' | '=' | '>=' | '<=', valueList: [S[K]]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], comparator: '>' | '<' | '=' | '>=' | '<=', valueList: [S[K1], S[K2]]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], comparator: '>' | '<' | '=' | '>=' | '<=', valueList: [S[K1], S[K2], S[K3]]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], comparator: '>' | '<' | '=' | '>=' | '<=', valueList: [S[K1], S[K2], S[K3], S[K4]]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], comparator: '>' | '<' | '=' | '>=' | '<=', valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]]): this;
    where<K extends StringKey<S>>(selection: WhereEntry<S, K>[]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>>(selection: WhereEntryMulti2<S, K1, K2>[]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(selection: WhereEntryMulti3<S, K1, K2, K3>[]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(selection: WhereEntryMulti4<S, K1, K2, K3, K4>[]): this;
    where<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(selection: WhereEntryMulti5<S, K1, K2, K3, K4, K5>[]): this;
    where(selection: Partial<{
        [J in StringKey<S>]: S[J];
    }>): this;
    where<K extends StringKey<S>>(key: K, comparator: 'IS NOT NULL'): this;
    where<K extends StringKey<S>>(key: K, comparator: 'IN', values: S[K][]): this;
    where<K extends StringKey<S>>(key: K, comparator: '>' | '<' | '=' | '>=' | '<=' | 'CONTAINS', value: S[K]): this;
    whereIsNotNull<K extends StringKey<S>>(key: K): this;
    whereIn(where: {
        [K in StringKey<S>]: S[K];
    }[]): this;
    whereIn<K extends StringKey<S>>(keys: [K], valueList: [S[K]][]): this;
    whereIn<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], valueList: [S[K1], S[K2]][]): this;
    whereIn<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], valueList: [S[K1], S[K2], S[K3]][]): this;
    whereIn<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], valueList: [S[K1], S[K2], S[K3], S[K4]][]): this;
    whereIn<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]][]): this;
    whereIn<K extends StringKey<S>>(keys: K[], valueList: any[][]): this;
    whereIn<K extends StringKey<S>>(key: K, values: S[K][]): this;
    whereContains<K extends StringKey<S>>(keys: [K], valueList: [S[K]]): this;
    whereContains<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], valueList: [S[K1], S[K2]]): this;
    whereContains<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], valueList: [S[K1], S[K2], S[K3]]): this;
    whereContains<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], valueList: [S[K1], S[K2], S[K3], S[K4]]): this;
    whereContains<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]]): this;
    whereContains<K extends StringKey<S>>(keys: K[], valueList: S[K][]): this;
    whereContains<K extends StringKey<S>>(key: K, value: S[K]): this;
    whereLowerThan<K extends StringKey<S>>(keys: [K], valueList: [S[K]]): this;
    whereLowerThan<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], valueList: [S[K1], S[K2]]): this;
    whereLowerThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], valueList: [S[K1], S[K2], S[K3]]): this;
    whereLowerThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], valueList: [S[K1], S[K2], S[K3], S[K4]]): this;
    whereLowerThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]]): this;
    whereLowerThan<K extends StringKey<S>>(keys: K[], valueList: any[]): this;
    whereLowerThan<K extends StringKey<S>>(key: K, value: S[K]): this;
    whereGreaterThan<K extends StringKey<S>>(keys: [K], valueList: [S[K]]): this;
    whereGreaterThan<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], valueList: [S[K1], S[K2]]): this;
    whereGreaterThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], valueList: [S[K1], S[K2], S[K3]]): this;
    whereGreaterThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], valueList: [S[K1], S[K2], S[K3], S[K4]]): this;
    whereGreaterThan<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]]): this;
    whereGreaterThan<K extends StringKey<S>>(keys: K[], valueList: any[]): this;
    whereGreaterThan<K extends StringKey<S>>(key: K, value: S[K]): this;
    whereEquals<K extends StringKey<S>>(keys: [K], valueList: [S[K]]): this;
    whereEquals<K1 extends StringKey<S>, K2 extends StringKey<S>>(keys: [K1, K2], valueList: [S[K1], S[K2]]): this;
    whereEquals<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>>(keys: [K1, K2, K3], valueList: [S[K1], S[K2], S[K3]]): this;
    whereEquals<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>>(keys: [K1, K2, K3, K4], valueList: [S[K1], S[K2], S[K3], S[K4]]): this;
    whereEquals<K1 extends StringKey<S>, K2 extends StringKey<S>, K3 extends StringKey<S>, K4 extends StringKey<S>, K5 extends StringKey<S>>(keys: [K1, K2, K3, K4, K5], valueList: [S[K1], S[K2], S[K3], S[K4], S[K5]]): this;
    whereEquals<K extends StringKey<S>>(keys: K[], valueList: any[]): this;
    whereEquals<K extends StringKey<S>>(key: K, value: S[K]): this;
    hasWhereClauses(): boolean;
    getWhereParams(): any[];
    getWhereQuery(): string;
}
